/**
 * Created by janis dähne.
 */


function convertString(stringWithQuotes: string): string {
  return stringWithQuotes.substr(1, stringWithQuotes.length-2)
}

function convertNumber(num: string): number | null {

  let result = parseFloat(num)

  if (isNaN(result)) {
    return null
  }

  return result
}

class AstHelper {

  /**
   * some rules (e.g. notes) are placed on the preceding entity
   * this saves the last known entity so that the value is known
   * @type {any}
   */
  static lastKnownEntityName: string | null = null

  /**
   * the model used in the parser for results
   */
  static model: ClassDiagram

  /**
   * the current relation id ... this is incremented every time a new relation is found
   * so use this with -1 to get the last relation id
   */
  static currentRelationId: number


  static reset(): void {
    AstHelper.lastKnownEntityName = null
    AstHelper.currentRelationId = 0

  }

}