/**
 * Created by janis dähne.
 */


let comp = new PumclCompiler(pumcl)


let x =
  `

//---classes

class Student
class Courses

Student " 0..*" -- " 1..*" Courses

class Enrollment {
  studentId: number
  courseId: number
  drop()
  cancel() : void
}

(Student, Courses) .. Enrollment

class C1 {
  property: int
  property2: int
  method(): void
  method2(): void
}

class C2<T> {
  property: int
  method(): void
}

class C3 <<important>> {
  property: int
  method(): void
}

class C4<T> <<important>> {
  property: int
  method(): void
}

class C5 as "C5 Text" {
  property: int
  method(): void
}

package System {
  class Console{
    buffer: int[]
    write(s: string): void
  }
  package Out {
    class Test<T> as "Inside Out Package" {
      buffer: int[]
      write(s: string): void
    }
  }
}

C1 -- C2
C3 -- C2 : "link name"

C3 "1" -- "*" C4
C4 "1" : "c4s" -- "*" : "c5s" C5 : "link name with direction" >

System::Console -- C1
System::Out::Test -- C1

//---interfaces

interface I1 {
  method(): void
}

interface I2<T> as "I2 Text" {
  method(): void
  method2(): void
}

interface I3 <<important>> {
  method(): void
}

interface I4<T> <<important>> {
  method(): void
}

I1 -- I2
note on link: "two interfaces"
I2 -- I3
I3 -- I4

//--- enums

enum E1 {
  Two
}

enum E2 <<important>> {
  One = 1
  Two = 3
}

enum E3 as "E3 Text" {
  One = "1"
  Two =  "Two long text"
}
enum E4 as "E4 Text" {
  One = "1"
  Two =  "Two"
}

E1 -- E2
E3 -- E4
E2 -- E3

//--- notes

note "just a note" //this will get the name noteX (anonymous note)

note "just another note 
 on E1 note (two lines)" as n1

n1 -- E2
n1 .. E4
`


/*

X "*" : "x" -- "1" : "y" Y

class X {
  test<T : List<T>[]>(x: List<int, string[], Pair<Num, X>>[][]) : List<T>
  test<T : List<T>[]>(x: List<int, string[], Pair<Num, X>>[][]) : List<T>
}

class Y <T> as "XY123123123123Z" <<STEREO>>  {

  }

class Y2  {
   {static} xxx
   yyy : int
   {abstract} foo()
   fff()
  }

  interface IEnumerate {
    foo(): x
  }
  interface IEnumerate2 <<st>>

  enum XXX {
  }

  enum Dates <<int>> {
  X
  Y = 1
  K = "asda"
  }
 */

// x = themeTest001

var res = comp.parse(x)

console.log(res)

var code = TransformToGraphviz.generateCode(res)
console.log(code)

//var res2 = TransformToGraphviz.toSvg(code, 'png-image-element')
var res2 = TransformToGraphviz.toImage(code)
//console.log(res2)

let div = <HTMLDivElement>document.getElementById('stage')

//div.appendChild(res2)
div.innerHTML = res2

let divOutCode = <HTMLDivElement>document.getElementById('codeOut')
divOutCode.innerText = code

//displayTestResult(runTest(x))


function generateDia(): void {

  let editorTextarea = <HTMLTextAreaElement>document.getElementById('editor')
  let model = comp.parse(editorTextarea.value)
  console.log(model)
  let dotCode = TransformToGraphviz.generateCode(model)
  console.log(dotCode)
  let svg = TransformToGraphviz.toImage(dotCode)
  let stage = <HTMLDivElement> document.getElementById('stage0')
  stage.innerHTML = svg

}