/**
 * Created by janis dähne.
 */

/*
contains the model for an uml class diagram
*/


/**
 * all top level entities
 *
 * the model can be used
 * if all parent packages are set
 * if all names are full qualified
 *
 */
interface ClassDiagram extends PackageShaped {


  //--- entities

  //--- these entities have no package (because first level = default package = parent package = null)...
  classes: Class[]
  interfaces: Interface[]
  enums: Enumeration[]
  associationClasses: AssociationClass[]


  subPackages: Package[]

  notes: Note[]
  pointingNotes: PointingNote[]

  //--- relations

  relations: Relation[]

  /**
   * all found primitive types
   * primitive types are all types that
   * are not classes, interfaces or enums
   *
   * inside a class there can only be primitive types or generic types
   * (for property types, method types...)
   *
   * else we would have a relation
   */
  primitiveTypes: Type[]


  //TODo set via ast traversal

  identifiersMap: IdentifiersMap

  primitiveTypesMap: PrimitiveTypesMap

}