/**
 * Created by janis dähne.
 */

interface Entity {}

interface ThingInsideContainer {
  parentPackage: Package | null
  //parentNamespace: Namespace | null
}

interface Aliasable {
  displayName_pk: string
  /**
   * when (re)named with as ...
   */
  alias: string | null
}

interface PackageShaped {
  classes: Class[]
  interfaces: Interface[]
  enums: Enumeration[]
  associationClasses: AssociationClass[]

  subPackages: Package[]
}

/**
 * e.g. class List<T : IComparable> or
 * bar<T : List<T>>()
 *
 */
interface GenericsDefinition {
  parameterName: string
  constraint: Type | null //TODO MUST array???
}

interface Type {
  name_pk: string

  /**
   * e.g. Tuple<int, string>[]
   */
  appliedGenerics: Type[]

  /**
   * only if the type is an array
   * e.g. int[] would have type int and dimension 1, int[][][] dimension 3
   */
  arrayDimension: number | null
}



/**
 * we need the _ because these are keywords in js
 */
enum VisibilityModifier {
  _public = 0,
  _private = 1,
  _protected = 2,
  _packagePrivate = 3
}

/**
 * not js keywords but the be more conform to other modifiers
 */
enum OtherModifier {
  _static = 0,
  _abstract = 1
}

enum PointingDirection {
  left = 0,
  top = 1,
  right = 2,
  bot = 3
}


/**
 * how a line is connected to the entity
 */
enum LinkKind {
  normal = 0,
  arrow = 1,
  generalization = 2,
  composition = 3,
  aggregation = 4,

  //not uml ones
  box = 5,
  cross = 6,
  trident = 7,
  circlePlus = 8,
  generalization2 = 9
}

enum RelationDirection {
  startToEnd = 0,
  endToStart = 1
}