/**
 * Created by janis dähne.
 */



interface RelationNode {
  entityName: string
  /**
   * the link type how the line is connected to the entity
   */
  linkKind: LinkKind

  /**
   * the cardinality of this end of the relation
   */
  cardinality: string | null

  /**
   * note that the e.g. X -- "*" : "ys" Y
   * the property name is then part of X (and not Y)
   * so we would get X.ys (and not Y.ys)
   */
  propertyName: string | null
  visibilityModifier: VisibilityModifier | null
}

/**
 * a relation/link/connection e.g.
 * X -- Y
 */
interface Relation {

  /**
   * a unique relation id
   * needed for association classes
   */
  relationId: number

  /**
   * actually for all lines there is a dashed version...
   */
  isDashed: boolean

  name: string | null

  /**
   * entity where the line should start e.g. X
   */
  startNode: RelationNode
  /**
   * entity where the line should end e.g. Y
   */
  endNode: RelationNode

  /**
   * the direction of the relation if any
   */
  relationDirection: RelationDirection | null

}