/**
 * Created by janis dähne.
 */



class AssociationClassBuilder {

  static createAssociationClass(displayName_pk: string,
                                relationId: number,
                                entityName1: string,
                                entityName2: string,
                                alias: string | null = null,
                                parentPackage: Package | null = null
                                ): AssociationClass {
    return {
      displayName_pk,
      relationId,
      entityName1,
      entityName2,
      alias,
      parentPackage
    }
  }

  static setDisplayName(target: AssociationClass, displayName_pk: string): AssociationClass {
    return set(target, 'displayName_pk', displayName_pk)
  }

  static setRelationId(target: AssociationClass, relationId: number): AssociationClass {
    return set(target, 'relationId', relationId)
  }

  static setEntityName1(target: AssociationClass, entityName1: string): AssociationClass {
    return set(target, 'entityName1', entityName1)
  }

  static setEntityName2(target: AssociationClass, entityName2: string): AssociationClass {
    return set(target, 'entityName2', entityName2)
  }

  static setAlias(target: AssociationClass, alias: string): AssociationClass {
    return set(target, 'alias', alias)
  }

  static setPackage(target: AssociationClass, _package: Package): AssociationClass {
    return set(target, 'parentPackage', _package)
  }

}