/**
 * Created by janis dähne.
 */


class MethodBuilder {
  static createMethod(name_pk: string,
                      returnType: Type | null = null,
                      visibilityModifier: VisibilityModifier | null = null,
                      otherModifier: OtherModifier | null = null,
                      parameters: Property[] = [],
                      genericsDefinitions: GenericsDefinition[]): Method {
    return {
      name_pk,
      returnType,
      visibilityModifier,
      otherModifier,
      parameters,
      genericsDefinitions,
    }
  }


  static setName(target: Method, name_pk: string): Method {
    return set(target, 'name_pk', name_pk)
  }

  static setReturnType(target: Method, returnType: Type | null ): Method {
    return set(target, 'returnType', returnType)
  }

  static setVisibilityModifier(target: Method, visibilityModifier: VisibilityModifier | null): Method {
    return set(target, 'visibilityModifier', visibilityModifier)
  }

  static setOtherModifier(target: Method, otherModifier: OtherModifier | null = null): Method {
    return set(target, 'otherModifier', otherModifier)
  }

  static addParameter(target: Method, parameter: Property): Method {
    target.parameters.push(parameter)
    return target
  }

  static addManyParameters(target: Method, parameters: Property[]): Method {
    target.parameters = target.parameters.concat(parameters)
    return target
  }

  static addGenericsDefinition(target: Method, genericsDefinition: GenericsDefinition): Method {
    target.genericsDefinitions.push(genericsDefinition)
    return target
  }

  static addManyGenericsDefinitions(target: Method, genericsDefinitions: GenericsDefinition[]): Method {
    target.genericsDefinitions = target.genericsDefinitions.concat(genericsDefinitions)
    return target
  }
}