/**
 * Created by janis dähne.
 */


class PropertyBuilder {
  static createProperty(name_pk: string, type: Type | null = null,
                        visibilityModifier: VisibilityModifier | null = null,
                        otherModifier: OtherModifier | null = null): Property {
    return {
      name_pk,
      type,
      visibilityModifier,
      otherModifier
    }
  }


  static setName(target: Property, name_pk: string): Property {
    return set(target, 'name_pk', name_pk)
  }

  static setType(target: Property, type: Type | null): Property {
    return set(target, 'type', type)
  }

  static setVisibilityModifier(target: Property, visibilityModifier: VisibilityModifier | null): Property {
    return set(target, 'visibilityModifier', visibilityModifier)
  }

  static setOtherModifier(target: Property, otherModifier: OtherModifier | null = null): Property {
    return set(target, 'otherModifier', otherModifier)
  }

}