/**
 * Created by janis dähne.
 */


class EnumBuilder {
  static createEnum(displayName_pk: string,
                    stereotype: string | null = null,
                    alias: string | null = null,
                    parentPackage: Package | null = null,): Enumeration {

    return {
      displayName_pk,
      alias,
      stereotype,
      parentPackage,
      values: [],
    }
  }

  static setDisplayName(target: Enumeration, displayName_pk: string): Enumeration {
    return set(target, 'displayName_pk', displayName_pk)
  }

  static setStereotype(target: Enumeration, stereotype: string): Enumeration {
    return set(target, 'stereotype', stereotype)
  }

  static setAlias(target: Enumeration, alias: string): Enumeration {
    return set(target, 'alias', alias)
  }

  static setPackage(target: Enumeration, _package: Package): Enumeration {
    return set(target, 'parentPackage', _package)
  }

  static addValue(target: Enumeration, value: EnumValue): Enumeration {
    target.values.push(value)
    return target
  }

  static addManyValues(target: Enumeration, value: EnumValue[]): Enumeration {
    target.values = target.values.concat(value)
    return target
  }
}