/**
 * Created by janis dähne.
 */


class InterfaceBuilder {

  static createInterface(displayName_pk: string,
                         stereotype: string | null = null,
                         alias: string | null = null,
                         parentPackage: Package | null = null,): Interface {
    return {
      displayName_pk,
      alias,
      parentPackage,
      stereotype,
      methods: [],
      genericsDefinitions: []
    }
  }

  static setDisplayName(target: Interface, displayName_pk: string): Interface {
    return set(target, 'displayName_pk', displayName_pk)
  }

  static setStereotype(target: Interface, stereotype: string): Interface {
    return set(target, 'stereotype', stereotype)
  }

  static setAlias(target: Interface, alias: string): Interface {
    return set(target, 'alias', alias)
  }

  static setPackage(target: Interface, _package: Package): Interface {
    return set(target, 'parentPackage', _package)
  }

  static addMethod(target: Interface, method: InterfaceMethod): Interface {
    target.methods.push(method)
    return target
  }

  static addManyMethods(target: Interface, methods: InterfaceMethod[]): Interface {
    target.methods = target.methods.concat(methods)
    return target
  }

  static addGenericsDefinition(target: Interface, genericDefinition: GenericsDefinition): Interface {
    target.genericsDefinitions.push(genericDefinition)
    return target
  }
}











