/**
 * Created by janis dähne.
 */

function set<T, TKey extends keyof T, TValue>(target: T, property: TKey, value: T[TKey]): T {
  target[property] = value
  return target
}

/*
we use methods and return the classes because we may want to switch to real js classes and use
a fluent api...
 */


class ModelBuilder {

  static createModel(): ClassDiagram {
    return {
      subPackages: [],
      classes: [],
      interfaces: [],
      enums: [],
      notes: [],
      pointingNotes: [],
      relations: [],
      primitiveTypes: [],
      associationClasses: []
    }
  }

  static addPackage(target: ClassDiagram, _package: Package): ClassDiagram {
    target.subPackages.push(_package)
    return target
  }

  static addClass(target: ClassDiagram, _class: Class): ClassDiagram {
    target.classes.push(_class)
    return target
  }

  static addInterface(target: ClassDiagram, _interface: Interface): ClassDiagram {
    target.interfaces.push(_interface)
    return target
  }

  static addEnum(target: ClassDiagram, _enum: Enumeration): ClassDiagram {
    target.enums.push(_enum)
    return target
  }

  static addNote(target: ClassDiagram, _note: Note): ClassDiagram {
    target.notes.push(_note)
    return target
  }

  static addPointingNote(target: ClassDiagram, _pointingNote: PointingNote): ClassDiagram {
    target.pointingNotes.push(_pointingNote)
    return target
  }

  static addRelation(target: ClassDiagram, _relation: Relation): ClassDiagram {
    target.relations.push(_relation)
    return target
  }

  static addAssociationClass(target: ClassDiagram, _associationClass: AssociationClass): ClassDiagram {
    target.associationClasses.push(_associationClass)
    return target
  }

  static addPrimitiveType(target: ClassDiagram, _type: Type): ClassDiagram {
    target.primitiveTypes.push(_type)
    return target
  }
}