/**
 * Created by janis dähne.
 */


class PackageBuilder {
  static createPackage(name_pk: string,
                       parentPackage: Package | null = null,
                       stereotype: string | null = null,
                       classes: Class[] = [],
                       interfaces: Interface[] = [],
                       enums: Enumeration[] = [],
                       associationClasses: AssociationClass[] = [],
                       subPackages: Package[] = []): Package {


    const target = {
      name_pk,
      parentPackage,
      stereotype,
      classes,
      interfaces,
      enums,
      associationClasses,
      subPackages,
    }

    return target
  }

  static assignParentPackage(parentPackage: Package, entities: ThingInsideContainer[]) {

  }

  static setName(target: Package, name_pk: string): Package {
    return set(target, 'name_pk', name_pk)
  }

  static setStereotype(target: Package, stereotype: string): Package {
    return set(target, 'stereotype', stereotype)
  }

  static setParentPackage(target: Package, parentPackage: Package): Package {
    return set(target, 'parentPackage', parentPackage)
  }

  static addClass(target: Package, _class: Class): Package {
    target.classes.push(_class)
    return target
  }

  static  addInterface(target: Package, _interface: Interface): Package {
    target.interfaces.push(_interface)
    return target
  }

  static addEnum(target: Package, _enum: Enumeration): Package {
    target.enums.push(_enum)
    return target
  }

  static addAssociationClass(target: Package, associationClass: AssociationClass): Package {
    target.associationClasses.push(associationClass)
    return target
  }

  static addSubPackage(target: Package, subPackage: Package): Package {
    target.subPackages.push(subPackage)
    return target
  }

}
