/**
 * Created by janis dähne.
 */


class RelationBuilder {

  static createRelation(relationId: number,
                        startNode: RelationNode,
                        endNode: RelationNode,
                        name: string | null = null,
                        isDashed: boolean = false,
                        relationDirection: RelationDirection | null = null): Relation {

    console.log(isDashed)
    return {
      relationId,
      startNode,
      endNode,
      name,
      isDashed,
      relationDirection
    }
  }

  static setRelationId(target: AssociationClass, relationId: number): AssociationClass {
    return set(target, 'relationId', relationId)
  }

  static setStartNode(target: Relation, startNode: RelationNode): Relation {
    target.startNode = startNode
    return target
  }

  static setEndNode(target: Relation, endNode: RelationNode): Relation {
    target.endNode = endNode
    return target
  }

  static setName(target: Relation, name: string): Relation {
    target.name = name
    return target
  }

  static setIsDashed(target: Relation, isDashed: boolean): Relation {
    target.isDashed = isDashed
    return target
  }

  static setRelationDirection(target: Relation, relationDirection: RelationDirection): Relation {
    target.relationDirection = relationDirection
    return target
  }

}