/**
 * Created by janis dähne.
 */


class RelationNodeBuilder {
  static createRelationNode(entityName: string,
                            linkKind: LinkKind = LinkKind.normal,
                            cardinality: string | null = null,
                            propertyName: string | null = null,
                            visibilityModifier: VisibilityModifier | null): RelationNode {
    return {
      entityName,
      linkKind,
      cardinality,
      propertyName,
      visibilityModifier
    }
  }

  static setEntityName(target: RelationNode, entityName: string): RelationNode {
    target.entityName = entityName
    return target
  }

  static setLinkKind(target: RelationNode, linkKind: LinkKind): RelationNode {
    target.linkKind = linkKind
    return target
  }

  static setCardinality(target: RelationNode, cardinality: string | null = null): RelationNode {
    target.cardinality = cardinality
    return target
  }

  static setPropertyName(target: RelationNode, propertyName: string | null = null): RelationNode {
    target.propertyName = propertyName
    return target
  }

  static setVisibilityModifier(target: RelationNode, visibilityModifier: VisibilityModifier | null): RelationNode {
    target.visibilityModifier = visibilityModifier
    return target
  }

}