/**
 * Created by janis dähne.
 */



const testsOk: string[] = [
  ``,
  `x<--ooo`,
  `x -- x`,
  `x -- x
  `,
  `x -- y`,
  `x1 -- y`,
  ` x   --   y`,
  //allow empty lines
  `x -- y
  
  
  
  y -- x`,

  //multi line
  `x -- y
  a -- b`,

  `x -- y
  a -- b
  `,

  `x -- y
  a -- b222
  
  `,

  `x -- y
  a -- b
  a2 --> b2`,

  `a .. b`,
  `a <-- b`,
  `a <.. b`,
  `a --> b`,
  `a ..> b`,

  `a <|-- b`,
  `a <|.. b`,
  `a --|> b`,
  `a ..|> b`,

  `a *-- b`,
  `a *.. b`,
  `a --* b`,
  `a ..* b`,

  `a o-- b`,
  `a o.. b`,
  `a --o b`,
  `a ..o b`,

  //cardinality is a string enclosed in ""
  `x "*" .. y`,
  `x  -- "*" y`,
  `x --> "10" y`,
  `x "1" -- "*" y`,
  `x "100" -- "many" y`,
  `x "*" -- "*" y`,
  `x "1many1" -- "*asd*" y`,
  `x "*" .. "spaces ??? yay" y`,

  //with text
  `x -- y : "spaces allowed"`,
  `x "1" -- y : "0contains"`,
  `x "1" -- "*" y : "0contains"`,
  `x "1" -- y : "0contains"`,
  `x -- "1" y : "0contains"`,

  //with direction
  `x -- y : <`,
  `x -- y : >`,
  `x --> y : >`,
  `x <.. y : >`,

  `x --> y : "right" >`,
  `x --> y : < "left"`,

  //empty class

  `class Foo`,

  //class members

  `Foo : isOk`,
  `Foo : isOk : bool`, //see todo if we need a : here
  `Foo : bool isOk`,
  `Foo : isOks : bool[]`, //see todo if we need a : here
  `Foo : bool[] isOks`,
  `Bar : check()`,
  `Bar : check() : bool`, //see todo if we need a : here
  `Bar : bool check()`,
  `Bar : check() : bool[]`, //see todo if we need a : here
  `Bar : bool[] check()`,

  //methods with params
  `Bar : check(param1)`,
  `Bar : check(param1) : void`,
  `Bar : void check(param1)`,

  `Bar : check(int param1)`,
  `Bar : check(param1 : int)`,

  `Bar : check(int param1, int param2)`,
  `Bar : check(int param1, param2)`,
  `Bar : check(param1, int param2)`,

  `Bar : check(param1 : int, param2 : int)`,
  `Bar : check(param1 : int, param2)`,
  `Bar : check(param1, param2 : int)`,
  `Bar : check(param1, int param2, param2 : int)`,

  `Bar : check(int[] param1)`,
  `Bar : check(param1 : int[])`,

  `Bar : check(int[] param1, int[] param2)`,
  `Bar : check(int[] param1, param2)`,
  `Bar : check(param1, int[] param2)`,

  `Bar : check(param1 : int[], param2 : int[])`,
  `Bar : check(param1 : int[], param2)`,
  `Bar : check(param1, param2 : int[])`,
  `Bar : check(param1, int[] param2, param2 : int[])`,

  `Bar : check(int[][][] param1)`,

  `Bar : check(param1, int param2, param2 : int) : void`,
  `Bar : void check(param1, int param2, param2 : int)`,


]

//only for the new parser
const testsOk15: string[] = [
  `x #-- x`,
  `x #.. x`,
  `x --# x`,
  `x ..# x`,
  `x x-- x`,
  `x x.. x`,
  `x --x x`,
  `x ..x x`,
  `x }-- x`,
  `x }.. x`,
  `x --{ x`,
  `x ..{ x`,
  `x +-- x`,
  `x +.. x`,
  `x --+ x`,
  `x ..+ x`,
  `x ^-- x`,
  `x ^.. x`,
  `x --^ x`,
  `x ..^ x`,
]

const testsOk2: string[] = [
  `class X {
  }`
  ,
  `class X {
  
  
  
  }`
  ,
  `class X {
    isOk
  }`
  ,
  `class X {
    isOk : bool
  }`
  ,
  `class X {
    bool isOk
  }`
  ,
  `class X {
    isOk : bool[]
  }`
  ,
  `class X {
    bool[] isOk
  }`
  ,
  `class X {
    check()
  }`
  ,
  `class X {
    check() : bool
  }`
  ,
  `class X {
    bool check()
  }`

  ,
  `class X {
    check() : bool[]
  }`
  ,
  `class X {
    bool[] check()
  }`
  ,
  //empty lines inside class
  `class X {
    isOk
    
    
    isOk2
  }`
  ,
  `class X {
    isOk
    isOk2
  }`
  ,
  `class X {
    isOk
    isOkFunc()
  }`
  ,
  `class X {
    isOkFunc()
    isOk
  }`
  ,
  `class X {
    isOkFunc()
    isOk
    check() : bool[]
  }`
  ,
  `class X {
    isOkFunc()
    isOk
    bool check() 
  }`
  ,
  `class X {
    isOkFunc()
    isOk
    bool[] check() 
  }`
  ,
  `class X {
  }
  class Y {
  }`
  ,
  `class X22 {
    data int
  }
  class Y {
    data
  }`
  ,
  `class X {
    isOkFunc()
    isOk
    check() : bool[]
    bool[] check2()
    bool isOk2 
  }
  class Y {
    isOk
    check2():int[]
    check2()
    string isOk2
    check2()
  }`
  ,
  `class X {
    {field} A_field
    {method} Some_method()
  }`
  ,
  `class X {
    {field} int A_field
    {method} int Some_method()
  }`
  ,
  `class X {
    {field} A_field : int
    {method} Some_method() : int
  }`
  ,
  `class X {
    {field} A_field : int
    {method} Some_method() : int[]
  }`
  ,
  `class X {
    +foo
    +foo2:int
  }`
  ,
  `class X {
    + int foo
    +foo2:int
    +foo3:int[]
  }`
  ,
  `class X {
    +foo()
    + int foo2()
    +foo3():int
    +foo4():int[]
  }`
  ,
  `class X {
    +foo
    -foo2:int
    ~foo3
    #foo3
    +foo()
    -foo2(p1, p2):int
    ~foo3(p1: int, int p2)
    #foo3(param1)
  }`
  ,
  `class X {
    + {field} foo
    + {method} foo2()
  }`
  ,
  `class X {
    + {field} int foo
    + {method} int foo2()
  }`
  ,
  `class X {
    + {field} foo : int
    + {method} foo2() : int
  }`
  ,
  `class X {
    + {field} foo : int
    + {method} foo2() : int[]
  }`
  ,

  //abstract & static
  `class X {
    {static} foo
    {classifier} foo
    {abstract} foo
    
    {static} foo()
    {classifier} foo()
    {abstract} foo()
  }`
  ,
  `class X {
    + {field} foo : int
    + {method} foo2() : int[]
  }`
  ,
  `class X {
    + {static} {field} foo : int
    - {classifier} {field} foo : int
    ~ {abstract} {field} foo : int
    
    # {static} {field} int foo
    + {classifier} {field} int foo
    + {abstract} {field} int foo
    
    + {static} {method} int[] foo2()
    + {classifier} {method} int[] foo2()
    + {abstract} {method} int[] foo2()
  }`
  ,
  //stereotypes
  `class X << general >>`
  ,
  `class X <<general>> {
  }`
  ,
  `class X << general >> {
    foo
    method()
  }`
  ,
  `class X << general >> {
    foo : int
    foo() : int
  }`

]


const testsOk3: string[] = [
  //notes
  `note "this is a test"
  `
  ,
  `note "this is a test" as N1`
  ,
  `class X
  note "connected to X"
  note "connected to X"
  
  note "connected to X"
  
  note top of X : "also connected to X"
  note left of X : "also connected to X"
  note right of X : "also connected to X"
  note bottom of X : "also connected to X"
  
  `
  ,
  `class X
  note "connected to X"
  note top of X : "also connected to X2"
  `
  ,
  `class X
  note top of X : "also connected to X"`
  ,
  `class X
  note top : "connected to X"
  
  class Y
  note left : "connected to Y"
  note top of X : "also connected to X"
  
  `
  ,
  `
  class X
  note "xxx" as N1
  note "yyy" as N2
  N1 .. X
  X .. N2
  `,
  `
  note "row 1
  row 2
  row3
  
  row 5"
  `,
  `
  class Dummy
  Dummy --> Foo : "A link"
  note on link: "note that is red"
  `
  ,
  `Dummy --> Foo : "A link"
  note on link: "black is default color?"
  `
  ,
  `Dummy --> Foo : "A link"
  note on link: "black is default color?"
  `
  ,
  `Dummy --> Foo : "A link"
   note top on link: "black is default color?"
   note bottom on link: "black is default color?"
   note left on link: "black is default color?"
   note right on link: "black is default color?"
  `
  ,


]


const testsOk4: string[] = [
  `abstract class AbstractList`
  ,
  `abstract class AbstractList
  `
  ,
  `
  abstract class AbstractList`
  ,
  `
  abstract class AbstractList
  `
  ,
  `abstract AbstractCollection
  `
  ,
  `abstract AbstractCollection {
  }
  `
  ,
  `abstract class AbstractList {
    void foo()
  }
  `
  ,
  `abstract class AbstractCollection {
  }
  `,
  `interface IList`,
  `interface IList {
  }`
  ,
  `interface IList {
  
  }`
  ,
  `interface IList {
    method()
  }`
  ,
  `interface IList {
  
    method()
  }`,
  `interface IList {
    method() : void
    
  }`
  ,
  `interface IList <<stereotype>>`
  ,
  `interface IList <<stereotype>> {
  
    void method(arg1)
    
  }`,
  //enums
  `enum Uni`,
  `enum Uni {
  }`
  ,
  `enum Uni {
  
  }`
  ,
  `enum MEMBER_ENUM {
    method
    field
  }`
  ,
  `enum Uni {
  
    KM
    m
    dc
    
    cm
    
  }`,
  `enum Uni {
    EUR
    DOLLAR
    
  }`
  ,
  `enum Uni <<stereotype_int>> {
  
     S
     
     ms
    
  }`
  ,
  `enum Uni <<stereotype_int>> {
     s = 0
     ms = "ms"
  }`,
  //(re)naming classes
  `class " This is my class" as class1`
  ,
  `class class2 as " It works this way too"`
  ,
  `class " This is my class" as class1 << test >> {
    foo : int
  }`
  ,
  `class class2 as " It works this way too" << test >> {
    foo : int
  }`
  ,
  `interface " This is my interface" as interface1`
  ,
  `interface interface2 as " It works this way too"`
  ,
  `interface " This is my interface" as interface1 << test >> {
    void foo()
  }`
  ,
  `interface interface2 as " It works this way too" << test >> {
    void foo()
  }`
  ,
  `enum " This is my enum" as enum1`
  ,
  `enum enum2 as " It works this way too"`
  ,
  `enum " This is my enum" as enum1 << test >> {
    DAY
    MONTH
    YEAR
  }`
  ,
  `enum enum2 as " It works this way too" << test >> {
  
    DAY
    MONTH
    YEAR
    
  }`
  ,

]

const testsOk5: string[] = [

  `class X {
    +bar<T>(x: T, T y) : bool
  }`
  ,
  `class X {
    +bar<T : String>(x: T, T y) : bool
  }`
  ,
  `class X {
    +bar<T : int[]>(x: T, T y) : bool
  }`
  ,
  `class X {
    -bar<T, T2 : IEnumerator>(x: T, T y) : T2
  }`
  ,
  `class X {
    bar<T : Tuple<String>>()
  }`
  ,
  `class X {
    -bar<T, T2 : Tuple<int, int, string>>(x: T, T y) : T2
  }`
  ,
  `class X {
    -bar<T, T2 : Tuple<int, int, Pair<int, int[]> >>(x: T, T y) : T2
  }`
  ,
  `class X {
    -bar<T : int, T2 : T>(x: T, T y) : T2
  }`
  ,
  //java wildcard
  `class X {
    -bar<? : Element>(x: T, T y) : T2
  }`
  ,
  `class X {
    -bar<?, T2>(x: T, T y) : T2
  }`
  ,

  `class X {
    -bar<T1 : Pair<int, string>[]>(x: T, T y) : T2
  }`
  ,
  //class level generics
  `class Foo<? : Element, T2>`
  ,
  `class Foo<? : Element, T2 : Pair<int, string[], List<int>>>`
  ,
  `class Foo<? : Element, T2 : Pair<int, string[], List<int>>> {
  }`
  ,
  `class Foo<? : Element, T2> {
    +test<T, T2>(p1 : T, T2 p2)
  }`

  ,
  //with stereotype
  `class Foo<? : Element, T2> << stereotype >>`
  ,
  `class Foo<? : Element, T2> << stereotype >> {
    foo() : void
  }`
  ,
  `class "display Text" as Foo<? : Element, T2> {
    foo() : void
  }`
  ,
  `class "display Text" as Foo<? : Element, T2> <<FactoryStereotype>> {
    foo() : void
  }`
  ,
  `class Foo<? : Element, T2> as "display Text" {
    foo() : void
  }`
  ,
  `class Foo<? : Element, T2 : List<string>> as "display Text" << stereotype >> {
    foo() : void
  }`
  ,
  `class CollectionHelper <<static>> {
      map<TIn, TOut>(array : Tin[]) : TOut[]
      filter<T>(T[] array, predicate : Func<T, bool>) : T[]
    }
  `
  ,
  `class Tuple<T1 : Pair<int, string>[]>`
  ,
  //lets go crazy ;)
  //from the readme
  `class Tuple<T1, T2 : Tuple3<int, string[], List<int>, Pair<string,long>[]>>`,
  "class Tuple<?, T2 : Tuple3<int, string[], List<int>, Pair<int,long>[]>>",

  //class level and method
  `
  class List<T> {
    +test<T, T2>(p1 : T, T2 p2)
    -test<T, T2 : int>(p1 : T, T2 p2)
    test<T, T2, T3>(p1 : T, T2 p2) : T3
    T test<T>(p1 : T)
    map<TIn, TOut>(array : Tin[]) : TOut[]
  }
`,
  `
  class List<T, T2> {
    +T data
    data : T2
  }
`
  ,

]

const testsOk6: string[] = [

  `interface X {
    bar<T>(x: T, T y) : bool
  }`
  ,
  `interface X {
    bar<T : String>(x: T, T y) : bool
  }`
  ,
  `interface X {
    bar<T : int[]>(x: T, T y) : bool
  }`
  ,
  `interface X {
    bar<T, T2 : IEnumerator>(x: T, T y) : T2
  }`
  ,
  `interface X {
    bar<T : Tuple<String>>()
  }`
  ,
  `interface X {
    bar<T, T2 : Tuple<int, int, string>>(x: T, T y) : T2
  }`
  ,
  `interface X {
    bar<T, T2 : Tuple<int, int, Pair<int, int[]> >>(x: T, T y) : T2
  }`
  ,
  `interface X {
    bar<T : int, T2 : T>(x: T, T y) : T2
  }`
  ,
  //java wildcard
  `interface X {
    bar<? : Element>(x: T, T y) : T2
  }`
  ,
  `interface X {
    bar<?, T2>(x: T, T y) : T2
  }`
  ,

  `interface X {
    bar<T1 : Pair<int, string>[]>(x: T, T y) : T2
  }`
  ,
  //class level generics
  `interface Foo<? : Element, T2>`
  ,
  `interface Foo<? : Element, T2 : Pair<int, string[], List<int>>>`
  ,
  `interface Foo<? : Element, T2 : Pair<int, string[], List<int>>> {
  }`
  ,
  `interface Foo<? : Element, T2> {
    test<T, T2>(p1 : T, T2 p2)
  }`

  ,
  //with stereotype
  `interface Foo<? : Element, T2> << stereotype >>`
  ,
  `interface Foo<? : Element, T2> << stereotype >> {
    foo() : void
  }`
  ,
  `interface "display Text" as Foo<? : Element, T2> {
    foo() : void
  }`
  ,
  `interface "display Text" as Foo<? : Element, T2> <<FactoryStereotype>> {
    foo() : void
  }`
  ,
  `interface Foo<? : Element, T2> as "display Text" {
    foo() : void
  }`
  ,
  `interface Foo<? : Element, T2 : List<string>> as "display Text" << stereotype >> {
    foo() : void
  }`
  ,
  `interface CollectionHelper <<static>> {
      map<TIn, TOut>(array : Tin[]) : TOut[]
      filter<T>(T[] array, predicate : Func<T, bool>) : T[]
    }
  `
  ,
  `interface Tuple<T1 : Pair<int, string>[]>`
  ,
  //lets go crazy ;)
  //from the readme
  `interface Tuple<T1, T2 : Tuple3<int, string[], List<int>, Pair<string,long>[]>>`,
  "interface Tuple<?, T2 : Tuple3<int, string[], List<int>, Pair<int,long>[]>>",

  //class level and method
  `
  interface List<T> {
    test<T, T2>(p1 : T, T2 p2)
    test<T, T2 : int>(p1 : T, T2 p2)
    test<T, T2, T3>(p1 : T, T2 p2) : T3
    T test<T>(p1 : T)
    map<TIn, TOut>(array : Tin[]) : TOut[]
  }
`
  ,
  `interface Java8Predicate<T> {
    boolean test(T t)
    negate1() : Java8Predicate<T> 
    Java8Predicate<T> negate1()
    Java8Predicate<T> negate2<T2>()
    Java8Predicate<T : int> negate3<T2>()
    Java8Predicate<? : T, T2 : int> negate4<T2>()
    Java8Predicate<? : T, T2 : int> negate5()
    
    negate6() : Java8Predicate<T>
    negate7<T2>() : Java8Predicate<T>
    negate8<T2>() : Java8Predicate<T>
    negate9<T2>() : Java8Predicate<?, T2>
    negate10() : Java8Predicate<?, T2>
  }
  `
  ,
  `interface Java8Predicate<T> {
    and(Java8Predicate<? : T> other) : Java8Predicate<T>
    or(Java8Predicate<? : T> other) : Java8Predicate<T>
    {static} isEqual(Object targetRef) : Java8Predicate<T>
    {static} Java8Predicate<T> isEqual(Object targetRef)
  }
  `

]

//should fail
const testsFail: string[] = [
  `1x-- y`,
  `x - -y`,
  `x-- - y`,
  //not supported yet
  `a < -- * b`,
  `a #--b`,
  `
a
x--
b`,
  `
a
}
--b`,
  `
a + --b`,
  `
a ^ --b`,

  `
a * -- > b`,
  `
a--# b`,
  `
a--
x
b`,
  `
a--
{
  b`,
  `
  a-- + b`,
  `
  a-- ^ b`,

  `
  x-- > y
: >
  right`, //not allowed
  `
  x--
  y : left < `, //not allowed

  `
  Bar : void check(int
  param1
)
  void`, //two method result types
  `
  Bar : void check(int
  param1
) :
  void`, //two method result types

  `

  class as

  `,
  `

  class Foo

  tooMuch`,

  // } NEWLINE //is not ok
  `

  class X {
  }

  class Y {
  }

  `
  ,
  `

  class X

<<
  general
  xxx >> ` //only text allowed (no whitespace)
  ,
  //not a color... TODO?
  `

  class X {
  #
    foo3
  #

    foo3(param1)
  }
`,
  //interface members are always implicite public
  `interface IList {
    +method()
    -method()
    ~method()
    # method()
  }`
  ,
  //interfaces have no fields...
  `interface IList {
    +field
    -field
    ~field
    # field
  }`,
  `class Foo <<stereotype>> <? : Element, T2>`
  ,
  // List<int> is a type and not a generic parameter
  `class Foo<? : Element>`
  ,
  //if we place a generic type we cannot restrict it because we use a type and not defining a new parameter
  `interface Java8Predicate<T> {
    negate6() : Java8Predicate<T : int>
  }
  `
  ,
  `
  class X {
    Java8Predicate<T : int> negate3<T2>()
  }
  `
  ,
]


// testsOk15.forEach(prog => {
//   displayTestResult(runTest(prog))
// })

// testsOk.forEach(prog => {
//   displayTestResult(runTest(prog))
// })
// //
// testsOk2.forEach(prog => {
//   displayTestResult(runTest(prog))
// })
//
// testsOk3.forEach(prog => {
//   displayTestResult(runTest(prog))
// })
//
// testsOk4.forEach(prog => {
//   displayTestResult(runTest(prog))
// })

// testsOk5.forEach(prog => {
//   displayTestResult(runTest(prog))
// })

// testsOk6.forEach(prog => {
//   displayTestResult(runTest(prog))
// })

// testsFail.forEach(prog => {
//   displayTestResult(runTest(prog))
// })