/**
 * Created by janis dähne.
 */


//a test containing all elements to check a theme


class TestTheme implements Theme {

  fontSizeInPx = 12
  fontName = 'Bitstream Vera Sans'

  graphBgColor = '#fdf6e3'
  classBgColor = '#eee8d5'
  classBorderColor = '#93a1a1'
  classFontColor = 'blue'

  interfaceBgColor = '#ee802f'
  interfaceBorderColor = '#fff203'
  interfaceFontColor = 'purple';

  enumBgColor = '#4dee94'
  enumBorderColor = '#29a134'
  enumFontColor = '#003c03';

  packageBgColor = '#aff4f9'
  packageBorderColor = '#0034a1'
  packageFontColor = '#fffffd'

  noteBgColor = '#f0b6d7'
  noteBorderColor = '#a10091'
  noteFrontColor = '#00c1f9'

  relationFontColor = '#bfbfbf'
  relationLineColor = '#ff4700'

  drawEntityNamesBold = true
}

//enable for testing
TransformToGraphviz.theme = new TestTheme()

let themeTest001 =
  `
//---classes

class Student
class Courses

Student " 0..*" -- " 1..*" Courses

class Enrollment {
  studentId: number
  courseId: number
  drop()
  cancel() : void
}

(Student, Courses) .. Enrollment

class C1 {
  property: int
  property2: int
  method(): void
  method2(): void
}

class C2<T> {
  property: int
  method(): void
}

class C3 <<important>> {
  property: int
  method(): void
}

class C4<T> <<important>> {
  property: int
  method(): void
}

class C5 as "C5 Text" {
  property: int
  method(): void
}

package System {
  class Console{
    buffer: int[]
    write(s: string): void
  }
  package Out {
    class Test<T> as "Inside Out Package" {
      buffer: int[]
      write(s: string): void
    }
  }
}

C1 -- C2
C3 -- C2 : "link name"

C3 "1" -- "*" C4
C4 "1" : "c4s" -- "*" : "c5s" C5 : "link name with direction" >

System::Console -- C1
System::Out::Test -- C1

//---interfaces

interface I1 {
  method(): void
}

interface I2<T> {
  method(): void
  method2(): void
}

interface I3 <<important>> {
  method(): void
}

interface I4<T> <<important>> {
  method(): void
}

interface I5 as "I5 Text" {
  method(): void
}

I1 -- I2
note on link: "two interfaces"
I2 -- I3
I4 --I5
I3 -- I4

//--- enums

enum E1 {
  Two
}

enum E2 <<important>> {
  One = 1
  Two = 3
}

enum E3 as "E3 Text" {
  One = "1"
  Two =  "Two long text"
}
enum E4 as "E4 Text" {
  One = "1"
  Two =  "Two"
}

E1 -- E2
E3 -- E4
E2 -- E3

//--- notes

note "just a note" //this will get the name noteX (anonymous note)

note "just another note \n on E1 note (two lines)" as n1

n1 -- E2
n1 .. E4

`